﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.7
@EndOfDesignText@
Sub Class_Globals
	Private nativeMe As JavaObject
	Private jo1 As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	nativeMe = Me
	jo1 = nativeMe.RunMethod("DownloadConfirmHelper", Null)
End Sub

Public Sub DOWNLOAD_CONFIRM_LISTENER As JavaObject
	Return jo1.RunMethod("DOWNLOAD_CONFIRM_LISTENER",Null)
End Sub

#if java

import android.app.Activity;
import android.os.AsyncTask;
import android.text.TextUtils;
import android.util.Log;

import com.qq.e.comm.compliance.DownloadConfirmCallBack;
import com.qq.e.comm.compliance.DownloadConfirmListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/*
 * created by timfeng 2021/2/2
 */
public class DownloadConfirmHelper {
  public static final String TAG = "DownloadConfirmHelper";
  public static boolean USE_CUSTOM_DIALOG = false;

  private static final String JSON_INFO_PARAMETER = "&resType=api";

  private static final String JSON_RESULT_KEY = "ret";
  private static final String JSON_DATA_KEY = "data";

  private static final String ICON_URL_KEY = "iconUrl";//App Icon
  private static final String APP_NAME_KEY = "appName";//App 名称
  private static final String VERSION_NAME_KEY = "versionName";//版本号
  private static final String AUTHOR_NAME_KEY = "authorName";//开发者
  private static final String PERMISSIONS_KEY = "permissions";//权限列表（具体权限信息，非URL）
  private static final String PRIVACY_AGREEMENT_KEY = "privacyAgreement";//隐私政策（URL）
  private static final String UPDATE_TIME_KEY = "apkPublishTime";//版本更新时间
  private static final String APK_FILE_SIZE_KEY = "fileSize";//apk文件大小，bytes

  public static class ApkInfo {
    public String iconUrl;
    public String appName;
    public String versionName;
    public String authorName;
    public List<String> permissions;
    public String privacyAgreementUrl;
    public long apkPublishTime;
    public long fileSize;
  }

  public static final DownloadConfirmListener DOWNLOAD_CONFIRM_LISTENER =
      new DownloadConfirmListener() {

        @Override
        public void onDownloadConfirm(Activity context, int scenes, String infoUrl,
                                      DownloadConfirmCallBack callBack) {
          Log.d(TAG, "scenes:" + scenes + " info url:" + infoUrl);

          //获取对应的json数据并自定义显示
          //new DownloadApkConfirmDialog(context, getApkJsonInfoUrl(infoUrl), callBack).show();

          new DownloadApkConfirmDialogWebView(context, infoUrl, callBack).show();//使用webview显示
        }
      };

  public static String getApkJsonInfoUrl(String infoUrl) {
    return infoUrl + JSON_INFO_PARAMETER;
  }

  public static ApkInfo getAppInfoFromJson(String jsonStr) {
    ApkInfo result = null;

    if (TextUtils.isEmpty(jsonStr)) {
      Log.d(TAG, "请求应用信息返回值为空");
      return null;
    }
    try {
      JSONObject json = new JSONObject(jsonStr);
      int retCode = json.optInt(JSON_RESULT_KEY, -1);
      if (retCode != 0) {
        Log.d(TAG, "请求应用信息返回值错误");
        return null;
      }
      JSONObject dataJson = json.optJSONObject(JSON_DATA_KEY);
      if (dataJson == null) {
        Log.d(TAG, "请求应用信息返回值错误" + JSON_DATA_KEY);
        return null;
      }

      if (dataJson != null) {
        result = new ApkInfo();
        result.iconUrl = dataJson.optString(ICON_URL_KEY);
        result.appName = dataJson.optString(APP_NAME_KEY);
        result.versionName = dataJson.optString(VERSION_NAME_KEY);
        result.authorName = dataJson.optString(AUTHOR_NAME_KEY);
        JSONArray jsonPermissions = dataJson.optJSONArray(PERMISSIONS_KEY);
        if (jsonPermissions != null) {
          result.permissions = new ArrayList<>();
          for (int i = 0; i < jsonPermissions.length(); i++) {
            result.permissions.add(jsonPermissions.getString(i));
          }
        }
        result.privacyAgreementUrl = dataJson.optString(PRIVACY_AGREEMENT_KEY);
        //后台返回的时间可能是秒也可能是毫秒，这里需要统一下为毫秒
        //2000年1月1日1时0分0秒对应的 秒是946688401 毫秒是 946688401000
        long publicTime = dataJson.optLong(UPDATE_TIME_KEY);
        result.apkPublishTime = publicTime > 946688401000L ? publicTime : publicTime * 1000;
        result.fileSize = dataJson.optLong(APK_FILE_SIZE_KEY);//单位是字节
      }
    } catch (JSONException e) {
      e.printStackTrace();
    }
    return result;
  }
}

#End If

#If java

import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.res.Configuration;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.webkit.WebResourceError;
import android.webkit.WebResourceRequest;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.qq.e.comm.compliance.DownloadConfirmCallBack;
import com.qq.e.union.demo.R;

/*
 * created by timfeng 2020/8/21
 */
public class DownloadApkConfirmDialogWebView extends Dialog implements View.OnClickListener {
  private static final String TAG = "ConfirmDialogWebView";
  private Context context;
  private int orientation;
  private DownloadConfirmCallBack callBack;
  private WebView webView;
  private ImageView close;
  private Button confirm;

  private ViewGroup contentHolder;
  private ProgressBar loadingBar;
  private Button reloadButton;

  private String url;
  private boolean urlLoadError = false;

  private static final String RELOAD_TEXT = "重新加载";
  private static final String LOAD_ERROR_TEXT = "抱歉，应用信息获取失败";

  public DownloadApkConfirmDialogWebView(Context context, String infoUrl,
                                         DownloadConfirmCallBack callBack) {
    super(context, R.style.DownloadConfirmDialogFullScreen);//需要全屏显示，同时显示非窗口蒙版
    this.context = context;
    this.callBack = callBack;
    this.url = infoUrl;
    orientation = context.getResources().getConfiguration().orientation;
    requestWindowFeature(Window.FEATURE_NO_TITLE);
    setCanceledOnTouchOutside(true);
    initView();
  }

  private void initView() {
    setContentView(R.layout.download_confirm_dialog);
    View root = findViewById(R.id.download_confirm_root);
    if (orientation == Configuration.ORIENTATION_PORTRAIT) {
      root.setBackgroundResource(R.drawable.download_confirm_background_portrait);
    } else if (orientation == Configuration.ORIENTATION_LANDSCAPE) {
      root.setBackgroundResource(R.drawable.download_confirm_background_landscape);
    }
    close = findViewById(R.id.download_confirm_close);
    close.setOnClickListener(this);
    reloadButton = findViewById(R.id.download_confirm_reload_button);
    reloadButton.setOnClickListener(this);
    confirm = findViewById(R.id.download_confirm_confirm);
    confirm.setOnClickListener(this);
    loadingBar = findViewById(R.id.download_confirm_progress_bar);
    contentHolder = findViewById(R.id.download_confirm_content);
    createTextView();
  }

  private void createTextView(){
    FrameLayout layout = findViewById(R.id.download_confirm_holder);
    webView = new WebView(context);
    webView.getSettings().setJavaScriptEnabled(true);
    webView.setWebViewClient(new Client());
    layout.addView(webView);
  }
  @Override
  public void show() {
    super.show();
    try {
      loadUrl(url);
    } catch (Exception e) {
      Log.e(DownloadApkConfirmDialogWebView.TAG, "load error url:" + url, e);
    }
  }


  private void loadUrl(String url) {
    if (TextUtils.isEmpty(url)) {
      loadingBar.setVisibility(View.GONE);
      contentHolder.setVisibility(View.GONE);
      reloadButton.setVisibility(View.VISIBLE);
      reloadButton.setText(LOAD_ERROR_TEXT);
      reloadButton.setEnabled(false);
      return;
    }
    urlLoadError = false;
    Log.d(TAG, "download confirm load url:" + url);
    webView.loadUrl(url);
  }

  @Override
  protected void onStart() {
    int height = PxUtils.getDeviceHeightInPixel(context);
    int width = PxUtils.getDeviceWidthInPixel(context);
    Window window = getWindow();
    window.getDecorView().setPadding(0, 0, 0, 0);
    WindowManager.LayoutParams layoutParams = window.getAttributes();
    if (orientation == Configuration.ORIENTATION_PORTRAIT) {
      layoutParams.width = WindowManager.LayoutParams.MATCH_PARENT;
      layoutParams.height = (int) (height * 0.6);
      layoutParams.gravity = Gravity.BOTTOM;
      layoutParams.windowAnimations = R.style.DownloadConfirmDialogAnimationUp;
    } else if (orientation == Configuration.ORIENTATION_LANDSCAPE) {
      layoutParams.width = (int) (width * 0.5);
      layoutParams.height = WindowManager.LayoutParams.MATCH_PARENT;
      layoutParams.gravity = Gravity.RIGHT;
      layoutParams.windowAnimations = R.style.DownloadConfirmDialogAnimationRight;
    }
    //弹窗外区域蒙版50%透明度
    layoutParams.dimAmount = 0.5f;

    //resume后动画会重复，在显示出来后重置无动画
    window.setAttributes(layoutParams);
    setOnShowListener(new OnShowListener() {
      @Override
      public void onShow(DialogInterface dialog) {
        try {
          Window window = getWindow();
          window.setWindowAnimations(0);
        } catch (Throwable t) {
        }
      }
    });
  }

  @Override
  public void onClick(View v) {
    if (v == close) {
      if (callBack != null) {
        callBack.onCancel();
      }
      dismiss();
    } else if (v == confirm) {
      if (callBack != null) {
        callBack.onConfirm();
      }
      dismiss();
    } else if (v == reloadButton) {
      loadUrl(url);
    }

  }

  @Override
  public void cancel() {
    super.cancel();
    if (callBack != null) {
      callBack.onCancel();
    }
  }

  class Client extends WebViewClient {
    @Override
    public void onPageFinished(WebView view, String url) {
      super.onPageFinished(view, url);
      if (!urlLoadError) {
        loadingBar.setVisibility(View.GONE);
        reloadButton.setVisibility(View.GONE);
        contentHolder.setVisibility(View.VISIBLE);
      }
    }

    @Override
    public void onReceivedError(WebView view, WebResourceRequest request, WebResourceError error) {
      super.onReceivedError(view, request, error);
      Log.d(TAG, "doConfirmWithInfo onReceivedError:" + error + " " + request);
      urlLoadError = true;
      loadingBar.setVisibility(View.GONE);
      contentHolder.setVisibility(View.GONE);
      reloadButton.setVisibility(View.VISIBLE);
      reloadButton.setText(RELOAD_TEXT);
      reloadButton.setEnabled(true);
    }
  }


}
#end if

#if java
import android.content.Context;
import android.content.res.Resources;
import android.util.DisplayMetrics;
import android.util.TypedValue;

Public class PxUtils {

  Public static int dpToPx(Context context, int dp) {
    Resources r = context.getApplicationContext().getResources();
    float px = TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, dp, r.getDisplayMetrics());
    Return (int) px;
  }

  Public static int pxToDp(Context context, int px) {
    float scale = context.getApplicationContext().getResources().getDisplayMetrics().density;
    return (int) (px / scale + 0.5f);
  }

  public static int getDeviceWidthInPixel(Context context) {
    DisplayMetrics dm = context.getApplicationContext().getResources().getDisplayMetrics();
    return dm.widthPixels;
  }

  public static int getDeviceHeightInPixel(Context context) {
    DisplayMetrics dm = context.getApplicationContext().getResources().getDisplayMetrics();
    return dm.heightPixels;
  }
}
#End If